/*
  Traffic Visor III Utilites  24.10.2006

  "-?" for help
*/

ReqPipeName = '\PIPE\TV3REQ'
LF = x2c('0A')

paramStr = strip(arg(1))
reqStr = Low(word(paramStr,1))
if reqStr = 'set' then
do
  ruleId = word(paramStr,2)
  if ruleId=='' then signal Usage
  reqStr = '?id='ruleId
end
else if reqStr = 'read' then reqStr = ''
else signal Usage

reqStr = 'GET /observer'reqStr
result = SendRequest(reqStr)
do forever
  rpos = pos(LF,result)
  if rpos=0 then
  do
    say result
    leave
  end
  else do
    say left(result,rpos-1)
    result = substr(result,rpos+1) 
  end
end

EXIT


SendRequest: procedure expose ReqPipeName
  rc = stream(ReqPipeName,'C','OPEN')
  Parse value rc with PipeState ':' OS2RC
  if OS2RC\='' then
  do
    say 'Cannot open a pipe'
    exit
  end
  rc = lineout(ReqPipeName,arg(1))
  rc = lineout(ReqPipeName,"")
  result = ''
  do forever
    line = charin(ReqPipeName,,1024)
    if line = '' then leave 
    result = result || line
   end
  rc = stream(ReqPipeName,'C','CLOSE')
return result

Low:
  return translate(arg(1),XRANGE('a','z'),XRANGE('A','Z'))

Usage:
  say "USAGE:"
  say "  observer.cmd <set ID|read>"
  say
  say "  set ID: start the observer on rule with ID, ID=-1 - stop observer"
  say "  read: read collected information"
  say
  say "EXAMPLE USAGE:";
  say "  observer.cmd set 10";
  say "  observer.cmd read";
  say "  observer.cmd set -1";
  exit
